<?php
// Cargar el archivo JSON
$jsonFile = 'data.json';
$jsonData = json_decode(file_get_contents($jsonFile), true);

// Guardar cambios si se envió el formulario
if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    $jsonData['usuarios'] = $_POST['usuarios'];
    file_put_contents($jsonFile, json_encode($jsonData, JSON_PRETTY_PRINT));
    $message = "Cambios guardados.";
}
?>

<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Editor JSON</title>
    <link rel="stylesheet" href="style.css">
    <style>
        body {
    font-family: Arial, sans-serif;
}

table {
    width: 100%;
    border-collapse: collapse;
}

th, td {
    padding: 10px;
    border: 1px solid #ccc;
}

input[type="text"], input[type="number"] {
    width: 100%;
}

    </style>
</head>
<body>
    <h1>Editor de JSON</h1>
    <?php if (isset($message)) : ?>
        <p><?php echo $message; ?></p>
    <?php endif; ?>

    <form method="POST">
        <table>
            <thead>
                <tr>
                    <th>ID</th>
                    <th>Nombre</th>
                    <th>Edad</th>
                </tr>
            </thead>
            <tbody>
                <?php foreach ($jsonData['usuarios'] as $usuario) : ?>
                    <tr>
                        <td><?php echo $usuario['id']; ?></td>
                        <td><input type="text" name="usuarios[<?php echo $usuario['id'] - 1; ?>][nombre]" value="<?php echo $usuario['nombre']; ?>"></td>
                        <td><input type="number" name="usuarios[<?php echo $usuario['id'] - 1; ?>][edad]" value="<?php echo $usuario['edad']; ?>"></td>
                    </tr>
                <?php endforeach; ?>
            </tbody>
        </table>
        <button type="submit">Guardar Cambios</button>
    </form>
</body>
</html>
