/*ELEMENTOS DEL NAVBAR */
const inputSearch = document.getElementById('inputSearch');
/*ELEMENTOS DEL FORMULARIO PARA CREAR*/
let claveBanner = document.querySelector('#inputClaveBanner');
let nombreBanner = document.querySelector('#inputNombreCurso');
let checkPresencial = document.querySelector('#checkPresencial');
let checkConnect = document.querySelector('#checkConnect');
const saveButton = document.querySelector('#saveButton');
/*ELEMENTOS DEL FORMULARIO PARA ACTUALIZAR*/
let claveBannerUpdate = document.querySelector('#inputClaveBannerUpdate');
let nombreBannerUpdate = document.querySelector('#inputNombreCursoUpdate');
let checkPresencialUpdate = document.querySelector('#checkPresencialUpdate');
let checkConnectUpdate = document.querySelector('#checkConnectUpdate');
const saveButtonUpdate = document.querySelector('#saveButtonUpdate');

let dto;

let btnCrear = document.querySelector('#createBtn');


if(location.hash.split('#')[1] != "edit"){
    btnCrear.classList.add('d-none')
}


// Elemento html donde se imprimirán las tarjetas.
let elementPrint = document.getElementById('print');

// Modal para creación de nota de enseñanza
const myModalEl = document.getElementById('createNote');
const modal = new bootstrap.Modal(myModalEl, {
    backdrop: 'static'
});
// Modal para actualizar nota de enseñanza
const myModalUpdate = document.getElementById('updateNote');
const modalUpdate = new bootstrap.Modal(myModalUpdate, {
    backdrop: 'static'
});

// Funcion para borrar elementos
let borrarElemento = async (claveElemento) => {
    fetch(`/api/data/${claveElemento}`, {
            method: 'DELETE'
        })
        .then(response => response.text())
        .then(message => {
            alert(message);
            elementPrint.innerHTML = '';
            handleInput();
        });
}

// Función para actualizar elementos
let funcionActualizarElemento = async (clave)=>{
    let newObject;
    const response = await fetch('/api/data');
    const data = await response.json();
    data.forEach((element,indice) =>{
        const { claveBanner, nombreCurso, versiones } = element;
        // Se imprime los valores del elemeto a actualizar en el modal.
        if(claveBanner == clave) {
            let indiceAObtener = (claveBannerUpdate)=>{
                indiceDelUpdate = data.findIndex(element => element.claveBanner === claveBannerUpdate)
                return indiceDelUpdate;
            }
            claveBannerUpdate.value = claveBanner;
            nombreBannerUpdate.value = nombreCurso;
            versiones.forEach(version =>{
                switch (version) {
                    case 'presencial':
                        checkPresencialUpdate.checked = true; 
                        break;
                    case 'connect':
                        checkConnectUpdate.checked = true; 
                        break;
                }
            })
            modalUpdate.show();
            // Si se da click en el botón de guardar cambios
            saveButtonUpdate.addEventListener('click', async (event)=>{
                event.preventDefault();
                
                // Si devuelve true la función quiere decir que se encuentra en el JSON, por lo que no se actualizará
            
                if( (indice != indiceAObtener(claveBannerUpdate.value)) && buscarEnJson(dto,claveBannerUpdate.value)){
                    alert('Elemento ya se encuentra en la base de datos, no se puede volver a agregar');
                }else{
                    if(validadorClave(claveBannerUpdate.value)){
                        

            
                newObject = {
                    "claveBanner": claveBannerUpdate.value.toUpperCase(),
                    "nombreCurso": nombreBannerUpdate.value,
                    "versiones": [`${checkPresencialUpdate.checked == true ? "presencial":""}`,
                        `${checkConnectUpdate.checked == true ? "connect":""}`
                    ].filter(Boolean)
                }
                

                if(Object.keys(newObject).length >0 ){
                    try{
                        const response = await fetch(`/api/data/${clave}`, {
                            method: 'PUT', // Método PUT para actualización
                            headers: {
                              'Content-Type': 'application/json',
                            },
                            body: JSON.stringify(newObject), // Enviamos el objeto como JSON
                          });
                          const result = await response.json();
                          if (response.ok) {
                            console.log('Actualización exitosa:', result);
                            alert('Actualización exitosa:');
                            modalUpdate.hide();
                            print.innerHTML="";
                            // handleInput();
                            location.reload();
                          } else {
                            console.error('Error en la actualización:', result.error);
                          }
                        } catch (error) {
                          console.error('Error de red:', error);
                        }
                }
            
                    }else{
                        alert('Clave ingresada no cumple el estandar')
                    }

                }
            })
            
        }
    })
}
    

    


// Limpiar el modal una vez que se cierre.
myModalUpdate.addEventListener('hide.bs.modal', function(){
    claveBannerUpdate.value="";
    nombreBannerUpdate.value="";
    checkPresencialUpdate.checked=false;
    checkConnectUpdate.checked=false;
})

// Función para imprimir elementos
function imprimirElemento(element) {
    const { claveBanner, nombreCurso, versiones } = element;
    document.getElementById('print').insertAdjacentHTML('beforeend', `
        <div class="col-lg-4 mb-3 my-4 mb-sm-0 d-flex">
            <div class="card flex-fill position-relative">
                ${location.hash.split('#')[1] == 'edit' ? ` <div class="btn-group position-absolute top-0 end-0 d-flex flex-column">
                    <button class="btn btn-outline-secondary btn-update" data-clave="${claveBanner}"><i class="bi bi-pencil-fill"></i></button>
                    <button class="btn btn-outline-secondary btn-delete" data-clave="${claveBanner}"><i class="bi bi-eraser-fill"></i></button>
                </div>` : ''}
               
                <div class="card-body d-flex flex-column">
                    <h5 class="card-title text-start flex-grow-1 mb-4">${claveBanner}<br><br>${nombreCurso}</h5>
                    <div class="d-flex justify-content-start">
                        ${versiones.includes('presencial') 
                        ? `<a href="files/${claveBanner}_NE.pdf" class="btn btn-sm btn-success me-2 download">Descargar NE</a>`
                        : ''}
                        ${versiones.includes('connect') 
                        ? `<a href="files/${claveBanner}c_NE.pdf" class="btn btn-sm btn-success me-2 download">Descargar NE connect</a>`
                        : ''}
                    </div>
                </div>
            </div>
        </div>`);
}



// Función de búsqueda dinámica
async function handleInput() {
    let query = inputSearch.value.toLowerCase();
    const response = await fetch('data.json');
    const data = await response.json();
    dto = data;
    document.getElementById('print').innerHTML = '';  // Limpia antes de insertar

    data.forEach(element => {
        const { claveBanner, nombreCurso } = element;
        if (claveBanner.toLowerCase().startsWith(query) || 
            nombreCurso.toLowerCase().startsWith(query) || 
            nombreCurso.toLowerCase().includes(query)) {
            imprimirElemento(element);
        }
    });

    setupDeleteButtons();
    setupUpdateButtons();
}

function setupDeleteButtons() {
    let botonesBorrar = document.querySelectorAll('.btn-delete');
    botonesBorrar.forEach(element => {
        element.addEventListener('click', async () => {
            let clave = element.getAttribute('data-clave');
            let result = confirm('¿Estás seguro de borrar el elemento?');
            if (result) await borrarElemento(clave);
        });
    });
}

function setupUpdateButtons() {
    let botonesUpdate = document.querySelectorAll('.btn-update');
    botonesUpdate.forEach(botonUpdate => {
        botonUpdate.addEventListener('click', function() {
            let clave = this.getAttribute('data-clave');
            funcionActualizarElemento(clave);
        });
    });
}

inputSearch.addEventListener('input', handleInput);



//   Eventos
myModalEl.addEventListener('shown.bs.modal', () => {
    claveBanner.focus();
})

// Manejar el envío del formulario
saveButton.addEventListener('click', async (event) => {
    event.preventDefault();
    let objectToCreate = {
        "claveBanner": claveBanner.value.toUpperCase(),
        "nombreCurso": nombreBanner.value,
        "versiones": [`${checkPresencial.checked == true ? "presencial":""}`,
            `${checkConnect.checked == true ? "connect":""}`
        ].filter(Boolean)
    }
    console.log(validadorClave(claveBanner.value));
    debugger
    if(validadorClave(claveBanner.value)){
        await fetch('/api/data', {
            method: 'POST',
            headers: {
                'Content-Type': 'application/json'
            },
            body: JSON.stringify(objectToCreate) // Asegúrate de que esto sea un objeto
        })
        .then((response) => {
            if (response.status == 200) {
                alert("Elemento creado exitosamente")
            } else {
                alert("No se puede crear este elemento, ya existe un elemento con esa clave")
            }
        })
        .catch((error) => console.log("Error:", error))
    //Se resetean los valores del formulario.
    claveBanner.value = '';
    nombreBanner.value = '';
    checkPresencial.checked = false;
    checkConnect.checked = false;
    elementPrint.innerHTML = '';
    handleInput();
    }
});


